/* 
ST_CHANG.PRC 
procs for structural change analysis
*/

fn x_ar(y,k)= packr(shiftr(ones(k,1)*(y'),seqa(1,1,k),miss(0,0))');

proc (2) = splitest(y,x,s,_trim);
local t,t1,t2,e,ss,xs,i,d,z,u,kest,tr;
t=rows(y);
t1=round(t*_trim);
t2=round(t*(1-_trim));
e=y-x*(y/x);
tr=seqa(1,1,t);
ss=zeros(t,1)+e'e;
if s.==0; xs=x; else; xs=x[.,s]; endif;
i=t1; do while i<=t2;
  d=(tr.>i);
  z=xs.*d;
  z=z-x*(z/x);
  u=e-z*(e/z);
  ss[i]=u'u;
i=i+1;endo;
kest=minindc(ss);
retp(kest,ss);
endp;

proc (4) = _supw(y,x,_trimsup,_trimexp);
local t,kk,f,t1,t2,i,d,j,z,beta,ze,supf,expf,e,v,_trim,fsup,kest,tr;
t=rows(y);
kk=cols(x);
f=zeros(t,kk+1);
_trim=minc(_trimsup|_trimexp);
tr=seqa(1,1,t);
t1=round(t*_trim);
t2=round(t*(1-_trim));
e=y-x*(y/x);
i=t1; do while i<=t2;
  d=(tr.>i);
  j=1; do while j<=kk;
    z=x[.,j].*d;
    z=z-x*(z/x);
    ze=z'e;
    beta=ze/moment(z,0);
    v=moment(z.*(e-z*beta),0);
    f[i,j]=(ze/v)'*ze;
  j=j+1;endo;
  z=x.*d;
  z=z-x*(z/x);
  ze=z'e;
  beta=ze/moment(z,0);
  v=moment(z.*(e-z*beta),0);
  f[i,kk+1]=(ze/v)'*ze;
i=i+1;endo;
t1=round(t*_trimsup);t2=round(t*(1-_trimsup));
fsup=zeros(t,kk+1);
fsup[t1:t2,.]=f[t1:t2,.];
kest=maxindc(fsup);
supf=maxc(fsup);
expf=ln(meanc(exp(f[round(t*_trimexp):round(t*(1-_trimexp)),.]/2)));
retp(fsup,supf,expf,kest);
endp;

proc (2) = bai_qnt(xsi,phi,alpha);
local xp,a,b,c,d,x1,x2,g1,g2,x,g,c1,c2;
xp=xsi/phi;
a=xp*(1+xp)/2;
b=1/2+xp;
c=phi*(phi+2*xsi)/(phi+xsi)/xsi;
d=((phi+2*xsi)^2)/xsi/(phi+xsi);
x1=seqa(-50,.01,5000);
x2=seqa(.01,.01,5000);
g1=-sqrt(-x1/(2*pi)).*exp(x1/8)-c.*exp(-x1*a).*cdfn(-b.*sqrt(-x1))
+(d-2-x1/2).*cdfn(-sqrt(-x1)/2);
a=(phi+xsi)/2;
b=(2*phi+xsi)/2/sqrt(phi);
c=xsi*(2*phi+xsi)/phi/(phi+xsi);
d=((2*phi+xsi)^2)/phi/(phi+xsi);
g2=1+xsi.*sqrt(x2/(2*pi*phi)).*exp(-x2*xsi*xsi/8/phi)
+c*exp(x2*a).*cdfn(-sqrt(x2)*b)
+(-d+2-x2*xsi*xsi/2/phi).*cdfn(-sqrt(x2/phi)*xsi/2);
x=x1|x2;
g=g1|g2;
c1=x[maxindc(g.>(alpha/2))];
c2=x[maxindc(g.>(1-alpha/2))];
retp(c1,c2);
endp;

proc qa_crit(k,_trim);
local crits,crit;
let crits[20,4]=
8.45	8.85	9.31	9.84
11.26	11.79	12.27	12.93
13.69	14.15	14.62	15.15
15.84	16.45	16.98	17.56
17.88	18.35	18.93	19.61
19.64	20.26	20.82	21.56
21.07	21.84	22.51	23.22
21.47	22.13	22.87	23.6
24.91	25.47	26.16	26.94
26.42	27.03	27.87	28.63
27.93	28.55	29.21	30.15
29.61	30.16	30.88	31.76
31.1	31.8	32.62	33.42
32.65	33.45	34.22	35
34.41	35.06	35.76	36.74
35.95	36.66	37.48	38.51
37.49	38.12	39.05	40.05
38.77	39.55	40.38	41.36
40.43	41.25	42.01	43.05
41.9	43	43.76	44.52;
if _trim==.2;
  crit=crits[k,1];
elseif _trim==.15;
  crit=crits[k,2];
elseif _trim==.10;
  crit=crits[k,3];
elseif _trim==.05;
  crit=crits[k,4];
else;
  crit=miss(0,0);
endif;
retp(crit);
endp;

proc ap_crit(k,_trim);
local crits,crit;
let crits[20,4]=
2.06	2.08	2.08	2.08
3.22	3.25	3.27	3.3
4.22	4.28	4.3	4.3
5.23	5.24	5.3	5.34
6.13	6.17	6.22	6.25
6.92	9.98	7.09	7.12
7.66	7.77	7.85	7.95
8.6	8.68	8.79	8.86
9.35	9.42	9.55	9.63
10.04	10.19	10.34	10.43
10.75	10.88	11.01	11.12
11.55	11.65	11.78	11.86
12.28	12.49	12.55	12.84
13.09	13.2	13.31	13.59
13.84	10.01	14.16	14.28
14.63	14.8	14.96	15.13
15.3	15.52	15.7	15.87
15.93	16.12	16.3	16.46
16.73	16.89	17.1	17.21
17.57	17.73	17.92	18;
if _trim==.15;
  crit=crits[k,1];
elseif _trim==.10;
  crit=crits[k,2];
elseif _trim==.05;
  crit=crits[k,3];
elseif _trim==.02;
  crit=crits[k,4];
else;
  crit=miss(0,0);
endif;
retp(crit);
endp;

proc chi_crit(k);
local crits,crit;
  let crits[20,1]= 3.84 5.99 7.81 9.49 11.07 12.59 14.07 15.51 16.92 18.31 
  19.68 21.03 22.36 23.68 25 26.3 27.59 28.87 30.14 31.41;
  crit=crits[k];
retp(crit);
endp;